*+
*+
*+    Source Module => F:\MAILMERG\MERGEDIT.PRG
*+
*+    Functions: Procedure MERGADD()
*+               Procedure MERGDEL()
*+               Procedure MERGEDIT()
*+               Procedure M_EDIT()
*+               Function MEMO_FUNC()
*+               Procedure EDIT_LINK_DATA()
*+
*+    Reformatted by Click! 1.11 on Oct-4-1997 at  3:07 am
*+
*+

#include "MAILMERG.CH"
#include "INKEY.CH"
#include "COMMON.CH"

static P_PROMPTS := {}
static P_TOKENS  := {}
static FNAMES    := {}
static LINK_DATA := ''

*+
*+
*+    Procedure MERGADD()
*+
*+    Called from ( merge.prg    )   1 - procedure merge()
*+
*+
*+
procedure MERGADD( )

local FILE_NAME := space( 8 )
local cDescript := space( 60 )
local nHandle

begin sequence

   ask_for( 'Enter a Description of the New Letter', @cDescript, '@K' )
   ask_for( 'Enter File Name of the New Letter', @FILE_NAME, '@!' )

   if empty( file_name )
      break
   endif

   FILE_NAME := 'LETTERS\' + left( alias(), 8 ) + '\' + alltrim( FILE_NAME )

   FILE_NAME := rootname( FILE_NAME ) + '.MRG'

   if file( file_name )
      pop_msg( 'File ' + FILE_NAME + ' already exists' )
      break
   endif

   LINK_DATA := mmheadmake( { cDescript } )

   if VERIFY( 'Create ' + FILE_NAME + '?', .t., 'Create', 'Abort' )
      nHandle := fcreate( FILE_NAME, 0 )
      fwrite( nHandle, link_data )
      fclose( nHandle )
   endif

end sequence

return

*+
*+
*+    Procedure MERGDEL()
*+
*+    Called from ( merge.prg    )   1 - procedure merge()
*+
*+
*+
procedure MERGDEL( )

local cFileName := PickLetter()

if !empty( cFileName )
   if verify( { 'Are you sure you want to delete this file', cFileName } )
      ferase( cFileName )
   endif
endif

return

*+
*+
*+    Procedure MERGEDIT()
*+
*+    Called from ( merge.prg    )   2 - procedure merge()
*+
*+
*+
procedure MERGEDIT( )

local x
local FILE_NAME
local WHEREAT
local Handle
local inarea    := select()

putscreen()

begin sequence

   FILE_NAME := PICKLETTER( 'LETTERS\' + left( alias(), 8 ) + "\*.MRG", '' )

   if empty( FILE_NAME )
      break
   endif

   // grab the printer tokens from the table
   P_PROMPTS := getprcod() [ 1 ]
   P_TOKENS  := getprcod() [ 2 ]

   select( inarea )

   M_EDIT( FILE_NAME )

   getscreen()

   asize( FNAMES, 0 )

end sequence

return

*+
*+
*+    Procedure M_EDIT()
*+
*+    Called from ( mergedit.prg )   1 - procedure mergedit()
*+
*+
*+
procedure M_EDIT( FILE_NAME )

local TXT          := memoread( FILE_NAME )
local LINK_DATAEND := at( HEADER_SEPARATOR, txt )
local DATA_FILE
local nFields
local x

begin sequence

   if LINK_DATAEND > 0
      LINK_DATA := mmheadtake( @txt )
   else

      EDIT_LINK_DATA( TXT )
      IF lastkey() == 27
         POP_MSG( 'You must select a file before you can edit' )
         break
      endif
      LINK_DATA := mmheadtake( LINK_DATA )
   endif

   nFields := fcount()
   asize( FNAMES, nFields )
   for x := 1 to nFields
      FNAMES[ x ] := pad( fieldname( x ), 12 ) + ' | ' + left( stringify( fieldget( x ) ), 40 )
   next

   * force initial insert mode
   readinsert( .t. )

   setcolor( 'G+/BG' )

   @  0,  0 to 0, 79 double
   attention( LINK_DATA[ 1 ], 0 )
   @ 23,  0 to 23, 79 double
   @ 23, 30 say ' Current Text File: ' + FILE_NAME + ' ' color 'bg+/bg'        
   ATTENTION( '^W-Save  <Esc>-Abort  <F3>-Fields  <F4>-Printer Codes', 24 )
   setcolor( 'N/BG' )
   TXT := memoedit( TXT, 1, 0, 22, 79, .t., "memo_func" )

   if !lastkey() = 27
      txt := MMHEADMAKE( LINK_DATA ) + txt
      memowrit( FILE_NAME, TXT )
   endif

end sequence

return

*+
*+
*+    Function MEMO_FUNC()
*+
*+
*+
function MEMO_FUNC( MODE, line, col )

local RET_VAL
local LKEY
local FIELD_NUM
local KEYSTROKES

setcursor( 0 )
@ 23,  6 say " Line: " + substr( ltrim( str( line, 4 ) ) + space( 4 ), 1, 4 ) color 'BG+/BG'        
@ 23, 17 say " Col: " + substr( ltrim( str( col, 4 ) ) + space( 4 ), 1, 4 )   color 'BG+/BG'        
setcursor( 1 )

if MODE == MEMO_STARTUP
   RET_VAL := MEMO_DEFAULT
else
   LKEY := lastkey()
   do case
   case LKEY == K_F3
      setcolor( 'GR+/GR,W+/B,,,W+/N' )
      FIELD_NUM := POPAPICK( 1, 25, 22, 71, FNAMES )
      setcolor( 'N/BG' )
      if FIELD_NUM != 0
         KEYSTROKES := LEFT_DELIM + fieldname( field_num ) + RIGHT_DELIM
         keyboard KEYSTROKES
      endif
      RET_VAL := MEMO_IGNORE
   case LKEY == K_F4
      setcolor( 'GR+/GR,W+/B,,,W+/N' )
      FIELD_NUM := POPAPICK( 1, 40, 22, 71, P_PROMPTS )
      setcolor( 'N/BG' )
      if FIELD_NUM != 0
         KEYSTROKES := LEFTPDELIM + trim( P_TOKENS[ field_num ] ) + RIGHTPDELIM
         keyboard KEYSTROKES
      endif
      RET_VAL := MEMO_IGNORE
   otherwise
      RET_VAL := MEMO_DEFAULT
   endcase
endif

return RET_VAL

*+
*+
*+    Procedure EDIT_LINK_DATA()
*+
*+    Called from ( mergedit.prg )   1 - procedure m_edit()
*+
*+
*+
procedure EDIT_LINK_DATA( TXT )

local inscreen
local page_length := 60
local PAGE_PAUSE  := .f.
local cDescript   := ''

LINK_DATA := mmheadtake( TXT )

if !empty( LINK_DATA )

   IF HEADER_SEPARATOR $ TXT
      if len( link_data ) < 1
         aadd( link_data, space( 60 ) )
      else
         cDescript := link_data[ 1 ]
      endif
   else
      cDescript := space( 60 )
   endif

endif

if empty( cDescript )
   ask_for( 'Enter a Description of this Letter', @cDescript, '@K' )
endif

LINK_DATA := mmheadmake( { cDescript } )

return

*+ EOF: MERGEDIT.PRG
