*+
*+
*+    Source Module => F:\MAILMERG\NEWXPND.PRG
*+
*+    Functions: Function EXPAND_TXT()
*+
*+       Tables: use PR_CODES NEW shared
*+
*+      Indexes: index on field->PR_TOKEN to PR_CODES
*+
*+    Reformatted by Click! 1.11 on Oct-4-1997 at  3:07 am
*+
*+

#include "MAILMERG.CH"

*+
*+
*+    Function EXPAND_TXT()
*+
*+    Called from ( mergprnt.prg )   1 - procedure mergprnt()
*+
*+
*+
function EXPAND_TXT( cMemoText )

local nStart
local nEnd
local cMetaType
local lNoTrim
local nFieldPos
local nFieldData
local lReplicate
local cReplicate
local cMetaSymbol
local cReplace
local cText
local CR           := chr( 13 )
local LF           := chr( 10 )
local CRLF         := CR + LF
local nLeftMargin  := 0
local nRightMargin := 78
local nPointer
local nCharCount
local cThisChar
local cTemp
local nInArea      := select()
local nWidth
local lReturn      := .t.

memvar SOME_TEXT

private SOME_TEXT

begin sequence

   putscreen()
   pop_msg( 'Processing and Printing Letter', .f. )

   lNoTrim := !( 0 = at( LEFTPDELIM + 'NOTRIM' + RIGHTPDELIM, cMemoText ) )

   if lNoTrim
      cMemoText := strtran( cMemoText, LEFTPDELIM + 'NOTRIM' + RIGHTPDELIM )
   endif

   // Perform Replicate function if necessary

   lReplicate := at( LEFTPDELIM + 'RC', cMemoText )
   do while lReplicate > 0
      cReplicate := substr( cMemoText, lReplicate + 1, 10 )

      cMemoText := left( cMemoText, lReplicate - 1 ) + ;
                         replicate( chr( val( substr( cReplicate, 3, 3 ) ) ), ;
                         val( substr( cReplicate, 7, 3 ) ) ) + ;
                         substr( cMemoText, lReplicate + 12 )

      lReplicate := at( LEFTPDELIM + 'RC', cMemoText )
   enddo

   // Process Meta symbols

   do while ( nStart := at( LEFT_DELIM, cMemoText ) ) > 0

      if inkey() = 27
         lReturn := .f.
         break
      endif

      // Expand the Meta symbol

      nEnd := at( RIGHT_DELIM, substr( cMemoText, nStart + 1 ) )

      if nEnd > 12 .or. nEnd == 0
         POP_MSG( '  Damaged Field Symbol => ' + ;
                  substr( cMemoText, nStart, 12 ) )
         lReturn := .f.
         break
      endif

      cMetaSymbol := substr( cMemoText, nStart + 1, nEnd - 1 )
      nFieldPos   := fieldpos( cMetaSymbol )

      if nFieldPos == 0
         POP_MSG( 'Field => ' + cMetaSymbol + ' <= not from this database.' )
         lReturn := .f.
         break
      else

         nFieldData := fieldget( nFieldPos )

         cMetaType := valtype( nFieldData )

         if cMetaType = 'C'
            if lNoTrim
               cReplace := nFieldData
            else
               cReplace := trim( nFieldData )
            endif
         elseif cMetaType = 'D'
            cReplace := dtoc( nFieldData )
         elseif cMetaType = 'N'
            if lNoTrim
               cReplace := str( nFieldData )
            else
               cReplace := ltrim( str( nFieldData ) )
            endif
         elseif cMetaType = 'M'
            cReplace := nFieldData
         endif
      endif

      // Insert the expanded symbol into the document

      cMemoText := stuff( cMemoText, nStart, len( cMetaSymbol ) + 2, cReplace )

   enddo

   // Transfer cMemoText to a temp variable and empty it.
   cText     := cMemoText
   cMemoText := ''

   // find soft carriage returns at the end of lines and remove them
   // Leave a space in their place
   cText := strtran( cText, '     ' + chr( 141 ) + chr( 10 ), ' ' )
   cText := strtran( cText, '    ' + chr( 141 ) + chr( 10 ), ' ' )
   cText := strtran( cText, '   ' + chr( 141 ) + chr( 10 ), ' ' )
   cText := strtran( cText, '  ' + chr( 141 ) + chr( 10 ), ' ' )
   cText := strtran( cText, ' ' + chr( 141 ) + chr( 10 ), ' ' )
   cText := strtran( cText, '' + chr( 141 ) + chr( 10 ), ' ' )

   // Look for Margins and Insert CRLF's & keep track of new margin commands
   // CRLF will be inserted between words for perfect wordwrap.

   do while !empty( cText )

      if inkey() = 27
         lReturn := .f.
         break
      endif

      nCharCount := 0
      nPointer   := 0
      nWidth     := nRightMargin - nLeftMargin

      // find the end of each line. If the line is longer than nWidth,
      // insert a CRLF where there is currently a space and start over.
      do while nCharCount < nWidth

         nPointer ++
         nCharCount ++

         cThisChar := substr( cText, nPointer, 1 )

         if cThisChar = CR
            exit
         elseif cThisChar = LEFTPDELIM
            if substr( cText, nPointer + 1, 2 ) = 'ML'
               nLeftMargin := val( substr( cText, nPointer + 3, 3 ) )
               nWidth      := nRightMargin - nLeftMargin
            endif
            if substr( cText, nPointer + 1, 2 ) = 'MR'
               nRightMargin := val( substr( cText, nPointer + 3, 3 ) )
               nWidth       := nRightMargin - nLeftMargin
            endif
            do while substr( cText, nPointer, 1 ) <> RIGHTPDELIM
               nPointer ++
            enddo
         endif

      enddo

      if cThisChar = CR
         // this means a CR was found before we reached the max width.
         if substr( cText, nPointer + 1, 1 ) == LF
            // if it was followed by a line feed, take them both
            nPointer ++
         endif
         cMemoText += left( cText, nPointer )
      else
         cTemp     := left( cText, nPointer )
         nPointer  := if( rat( ' ', cTemp ) = 0, nPointer, rat( ' ', cTemp ) )
         cMemoText += left( cText, nPointer ) + CRLF
      endif

      cText := substr( cText, nPointer + 1 )

   enddo

   // Look for Meta symbols for Printer Codes

   use PR_CODES NEW shared
   if file( 'pr_codes' + ordbagext() )
      set index to PR_CODES
   else
      index on field->PR_TOKEN to PR_CODES
   endif

   do while ( nStart := at( LEFTPDELIM, cMemoText ) ) > 0

      if inkey() == 27
         lReturn := .f.
         break
      endif

      // Expand the Printer Meta symbol

      nEnd := at( RIGHTPDELIM, substr( cMemoText, nStart + 1 ) )

      if nEnd > 12 .or. nEnd == 0
         POP_MSG( 'Location ' + alltrim( str( nStart, 5 ) ) + ;
                  ' Damaged Printer Code Symbol => ' + ;
                  substr( cMemoText, nStart, 12 ) )
         lReturn := .f.
         break
      endif

      cMetaSymbol := substr( cMemoText, nStart + 1, nEnd - 1 )
      cReplace    := ''

      if dbseek( cMetaSymbol )
         if upper( cMetaSymbol ) = 'DATEFULL'
            cReplace := cmonth( date() ) + ' ' + ;
                                substr( dtos( date() ), 5, 2 ) + ', ' + ;
                                str( year( date() ), 4 )
         else
            SOME_TEXT := PR_CODES->PR_CODE
            cReplace  := &SOME_TEXT
         endif
      endif

      // Insert the printer code in the letter
      cMemoText := stuff( cMemoText, nStart, len( cMetaSymbol ) + 2, cReplace )

   enddo

   pr_codes->( dbclosearea() )

   select( nInArea )

   ?? cMemoText

end sequence

getscreen()

return lReturn

*+ EOF: NEWXPND.PRG
